"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = mwPlugins;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _path = _interopRequireDefault(require("path"));

var _plugins = require("./plugins");

var _util = require("./util");

/**************************************************
 * Created by nanyuantingfeng on 27/10/2017 16:25.
 **************************************************/
function mwPlugins(_x, _x2) {
  return _mwPlugins.apply(this, arguments);
}

function _mwPlugins() {
  _mwPlugins = (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee(context, next) {
    var hash, compress, plugins, dll, ENV, filename, chunkFilename, cwd, outputPath, _context$records, records, _context$aggressive, aggressive, _context$analyzer, analyzer;

    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            context.plugins = [new _plugins.FriendlyErrorsWebpackPlugin({
              onErrors: function onErrors(severity, errors) {
                if (severity !== 'error') {
                  _util.notifier.notify({
                    title: 'hollow cli',
                    message: 'warn',
                    contentImage: _path.default.join(__dirname, '../assets/warn.png'),
                    sound: 'Glass'
                  });

                  return;
                }

                var error = errors[0];

                _util.notifier.notify({
                  title: 'hollow cli',
                  message: "".concat(severity, " : ").concat(error ? error.name : error),
                  subtitle: error ? error.file : error || '',
                  contentImage: _path.default.join(__dirname, '../assets/fail.png'),
                  sound: 'Glass'
                });
              }
            }), new _plugins.ProgressPlugin(_util.fnProgressHandler), new _plugins.HashedModuleIdsPlugin()];
            next();
            hash = context.hash, compress = context.compress, plugins = context.plugins, dll = context.dll, ENV = context.ENV;

            if (!Array.isArray(dll)) {
              context.webpackConfig.optimization.splitChunks = {
                chunks: 'all',
                minSize: 100,
                minChunks: 1,
                maxAsyncRequests: 6,
                maxInitialRequests: 3,
                name: !ENV.isProduction,
                cacheGroups: {
                  vendors: {
                    test: /[\\/]node_modules[\\/]/,
                    name: 'dependencies',
                    priority: -100,
                    reuseExistingChunk: true,
                    chunks: 'all'
                  },
                  default: false
                }
              };
            }

            filename = hash ? '[name]-[hash].css' : '[name].css';
            chunkFilename = hash ? '[id]-[hash].css' : '[id].css';
            plugins.push(new _plugins.MiniCssExtractPlugin({
              filename: filename,
              chunkFilename: chunkFilename
            }));
            context.webpackConfig.optimization.minimize = !!compress;

            if (compress) {
              context.webpackConfig.optimization.minimizer = [new _plugins.UglifyJsPlugin({
                cache: true,
                parallel: true,
                sourceMap: false
              }), new _plugins.OptimizeCSSAssetsPlugin({})];
            }

            cwd = context.cwd, outputPath = context.outputPath, _context$records = context.records, records = _context$records === void 0 ? false : _context$records, _context$aggressive = context.aggressive, aggressive = _context$aggressive === void 0 ? true : _context$aggressive, _context$analyzer = context.analyzer, analyzer = _context$analyzer === void 0 ? false : _context$analyzer; // dll 模式下不能使用当前插件

            if (!Array.isArray(dll) && aggressive === true) {
              plugins.push(new _plugins.AggressiveSplittingPlugin((0, _util.getOptions)(aggressive, {
                minSize: 1,
                maxSize: 1024 * 1024,
                chunkOverhead: 0,
                entryChunkMultiplicator: 1
              })));
            }

            plugins.push(new _plugins.HardSourceWebpackPlugin());
            context.plugins = plugins;

            if (records) {
              context.webpackConfig.recordsOutputPath = _path.default.join(cwd, outputPath, (0, _util.getOptions)(records, 'records.json'));
            }

            if (analyzer) {
              plugins.push(new _plugins.BundleAnalyzerPlugin((0, _util.getOptions)(analyzer)));
            }

          case 15:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _mwPlugins.apply(this, arguments);
}

module.exports = exports["default"];